(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.imageEdit = {}));
})(this, (function (exports) { 'use strict';

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || {
        __proto__: []
      } instanceof Array && function (d, b) {
        d.__proto__ = b;
      } || function (d, b) {
        for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
      };
      return extendStatics(d, b);
    };
    function __extends(d, b) {
      if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
      __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i];
          for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
      };
      return __assign.apply(this, arguments);
    };
    function __awaiter(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    }
    function __generator(thisArg, body) {
      var _ = {
          label: 0,
          sent: function () {
            if (t[0] & 1) throw t[1];
            return t[1];
          },
          trys: [],
          ops: []
        },
        f,
        y,
        t,
        g;
      return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
      }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
        return this;
      }), g;
      function verb(n) {
        return function (v) {
          return step([n, v]);
        };
      }
      function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
          if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
          if (y = 0, t) op = [op[0] & 2, t.value];
          switch (op[0]) {
            case 0:
            case 1:
              t = op;
              break;
            case 4:
              _.label++;
              return {
                value: op[1],
                done: false
              };
            case 5:
              _.label++;
              y = op[1];
              op = [0];
              continue;
            case 7:
              op = _.ops.pop();
              _.trys.pop();
              continue;
            default:
              if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                _ = 0;
                continue;
              }
              if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                _.label = op[1];
                break;
              }
              if (op[0] === 6 && _.label < t[1]) {
                _.label = t[1];
                t = op;
                break;
              }
              if (t && _.label < t[2]) {
                _.label = t[2];
                _.ops.push(op);
                break;
              }
              if (t[2]) _.ops.pop();
              _.trys.pop();
              continue;
          }
          op = body.call(thisArg, _);
        } catch (e) {
          op = [6, e];
          y = 0;
        } finally {
          f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
          value: op[0] ? op[1] : void 0,
          done: true
        };
      }
    }
    function __spreadArray(to, from, pack) {
      if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
          if (!ar) ar = Array.prototype.slice.call(from, 0, i);
          ar[i] = from[i];
        }
      }
      return to.concat(ar || Array.prototype.slice.call(from));
    }

    var eventsExports = {};
    var events = {
      get exports(){ return eventsExports; },
      set exports(v){ eventsExports = v; },
    };

    var R = typeof Reflect === 'object' ? Reflect : null;
    var ReflectApply = R && typeof R.apply === 'function' ? R.apply : function ReflectApply(target, receiver, args) {
      return Function.prototype.apply.call(target, receiver, args);
    };
    var ReflectOwnKeys;
    if (R && typeof R.ownKeys === 'function') {
      ReflectOwnKeys = R.ownKeys;
    } else if (Object.getOwnPropertySymbols) {
      ReflectOwnKeys = function ReflectOwnKeys(target) {
        return Object.getOwnPropertyNames(target).concat(Object.getOwnPropertySymbols(target));
      };
    } else {
      ReflectOwnKeys = function ReflectOwnKeys(target) {
        return Object.getOwnPropertyNames(target);
      };
    }
    function ProcessEmitWarning(warning) {
      if (console && console.warn) console.warn(warning);
    }
    var NumberIsNaN = Number.isNaN || function NumberIsNaN(value) {
      return value !== value;
    };
    function EventEmitter() {
      EventEmitter.init.call(this);
    }
    events.exports = EventEmitter;
    eventsExports.once = once;

    // Backwards-compat with node 0.10.x
    EventEmitter.EventEmitter = EventEmitter;
    EventEmitter.prototype._events = undefined;
    EventEmitter.prototype._eventsCount = 0;
    EventEmitter.prototype._maxListeners = undefined;

    // By default EventEmitters will print a warning if more than 10 listeners are
    // added to it. This is a useful default which helps finding memory leaks.
    var defaultMaxListeners = 10;
    function checkListener(listener) {
      if (typeof listener !== 'function') {
        throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof listener);
      }
    }
    Object.defineProperty(EventEmitter, 'defaultMaxListeners', {
      enumerable: true,
      get: function () {
        return defaultMaxListeners;
      },
      set: function (arg) {
        if (typeof arg !== 'number' || arg < 0 || NumberIsNaN(arg)) {
          throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + arg + '.');
        }
        defaultMaxListeners = arg;
      }
    });
    EventEmitter.init = function () {
      if (this._events === undefined || this._events === Object.getPrototypeOf(this)._events) {
        this._events = Object.create(null);
        this._eventsCount = 0;
      }
      this._maxListeners = this._maxListeners || undefined;
    };

    // Obviously not all Emitters should be limited to 10. This function allows
    // that to be increased. Set to zero for unlimited.
    EventEmitter.prototype.setMaxListeners = function setMaxListeners(n) {
      if (typeof n !== 'number' || n < 0 || NumberIsNaN(n)) {
        throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + n + '.');
      }
      this._maxListeners = n;
      return this;
    };
    function _getMaxListeners(that) {
      if (that._maxListeners === undefined) return EventEmitter.defaultMaxListeners;
      return that._maxListeners;
    }
    EventEmitter.prototype.getMaxListeners = function getMaxListeners() {
      return _getMaxListeners(this);
    };
    EventEmitter.prototype.emit = function emit(type) {
      var args = [];
      for (var i = 1; i < arguments.length; i++) args.push(arguments[i]);
      var doError = type === 'error';
      var events = this._events;
      if (events !== undefined) doError = doError && events.error === undefined;else if (!doError) return false;

      // If there is no 'error' event listener then throw.
      if (doError) {
        var er;
        if (args.length > 0) er = args[0];
        if (er instanceof Error) {
          // Note: The comments on the `throw` lines are intentional, they show
          // up in Node's output if this results in an unhandled exception.
          throw er; // Unhandled 'error' event
        }
        // At least give some kind of context to the user
        var err = new Error('Unhandled error.' + (er ? ' (' + er.message + ')' : ''));
        err.context = er;
        throw err; // Unhandled 'error' event
      }

      var handler = events[type];
      if (handler === undefined) return false;
      if (typeof handler === 'function') {
        ReflectApply(handler, this, args);
      } else {
        var len = handler.length;
        var listeners = arrayClone(handler, len);
        for (var i = 0; i < len; ++i) ReflectApply(listeners[i], this, args);
      }
      return true;
    };
    function _addListener(target, type, listener, prepend) {
      var m;
      var events;
      var existing;
      checkListener(listener);
      events = target._events;
      if (events === undefined) {
        events = target._events = Object.create(null);
        target._eventsCount = 0;
      } else {
        // To avoid recursion in the case that type === "newListener"! Before
        // adding it to the listeners, first emit "newListener".
        if (events.newListener !== undefined) {
          target.emit('newListener', type, listener.listener ? listener.listener : listener);

          // Re-assign `events` because a newListener handler could have caused the
          // this._events to be assigned to a new object
          events = target._events;
        }
        existing = events[type];
      }
      if (existing === undefined) {
        // Optimize the case of one listener. Don't need the extra array object.
        existing = events[type] = listener;
        ++target._eventsCount;
      } else {
        if (typeof existing === 'function') {
          // Adding the second element, need to change to array.
          existing = events[type] = prepend ? [listener, existing] : [existing, listener];
          // If we've already got an array, just append.
        } else if (prepend) {
          existing.unshift(listener);
        } else {
          existing.push(listener);
        }

        // Check for listener leak
        m = _getMaxListeners(target);
        if (m > 0 && existing.length > m && !existing.warned) {
          existing.warned = true;
          // No error code for this since it is a Warning
          // eslint-disable-next-line no-restricted-syntax
          var w = new Error('Possible EventEmitter memory leak detected. ' + existing.length + ' ' + String(type) + ' listeners ' + 'added. Use emitter.setMaxListeners() to ' + 'increase limit');
          w.name = 'MaxListenersExceededWarning';
          w.emitter = target;
          w.type = type;
          w.count = existing.length;
          ProcessEmitWarning(w);
        }
      }
      return target;
    }
    EventEmitter.prototype.addListener = function addListener(type, listener) {
      return _addListener(this, type, listener, false);
    };
    EventEmitter.prototype.on = EventEmitter.prototype.addListener;
    EventEmitter.prototype.prependListener = function prependListener(type, listener) {
      return _addListener(this, type, listener, true);
    };
    function onceWrapper() {
      if (!this.fired) {
        this.target.removeListener(this.type, this.wrapFn);
        this.fired = true;
        if (arguments.length === 0) return this.listener.call(this.target);
        return this.listener.apply(this.target, arguments);
      }
    }
    function _onceWrap(target, type, listener) {
      var state = {
        fired: false,
        wrapFn: undefined,
        target: target,
        type: type,
        listener: listener
      };
      var wrapped = onceWrapper.bind(state);
      wrapped.listener = listener;
      state.wrapFn = wrapped;
      return wrapped;
    }
    EventEmitter.prototype.once = function once(type, listener) {
      checkListener(listener);
      this.on(type, _onceWrap(this, type, listener));
      return this;
    };
    EventEmitter.prototype.prependOnceListener = function prependOnceListener(type, listener) {
      checkListener(listener);
      this.prependListener(type, _onceWrap(this, type, listener));
      return this;
    };

    // Emits a 'removeListener' event if and only if the listener was removed.
    EventEmitter.prototype.removeListener = function removeListener(type, listener) {
      var list, events, position, i, originalListener;
      checkListener(listener);
      events = this._events;
      if (events === undefined) return this;
      list = events[type];
      if (list === undefined) return this;
      if (list === listener || list.listener === listener) {
        if (--this._eventsCount === 0) this._events = Object.create(null);else {
          delete events[type];
          if (events.removeListener) this.emit('removeListener', type, list.listener || listener);
        }
      } else if (typeof list !== 'function') {
        position = -1;
        for (i = list.length - 1; i >= 0; i--) {
          if (list[i] === listener || list[i].listener === listener) {
            originalListener = list[i].listener;
            position = i;
            break;
          }
        }
        if (position < 0) return this;
        if (position === 0) list.shift();else {
          spliceOne(list, position);
        }
        if (list.length === 1) events[type] = list[0];
        if (events.removeListener !== undefined) this.emit('removeListener', type, originalListener || listener);
      }
      return this;
    };
    EventEmitter.prototype.off = EventEmitter.prototype.removeListener;
    EventEmitter.prototype.removeAllListeners = function removeAllListeners(type) {
      var listeners, events, i;
      events = this._events;
      if (events === undefined) return this;

      // not listening for removeListener, no need to emit
      if (events.removeListener === undefined) {
        if (arguments.length === 0) {
          this._events = Object.create(null);
          this._eventsCount = 0;
        } else if (events[type] !== undefined) {
          if (--this._eventsCount === 0) this._events = Object.create(null);else delete events[type];
        }
        return this;
      }

      // emit removeListener for all listeners on all events
      if (arguments.length === 0) {
        var keys = Object.keys(events);
        var key;
        for (i = 0; i < keys.length; ++i) {
          key = keys[i];
          if (key === 'removeListener') continue;
          this.removeAllListeners(key);
        }
        this.removeAllListeners('removeListener');
        this._events = Object.create(null);
        this._eventsCount = 0;
        return this;
      }
      listeners = events[type];
      if (typeof listeners === 'function') {
        this.removeListener(type, listeners);
      } else if (listeners !== undefined) {
        // LIFO order
        for (i = listeners.length - 1; i >= 0; i--) {
          this.removeListener(type, listeners[i]);
        }
      }
      return this;
    };
    function _listeners(target, type, unwrap) {
      var events = target._events;
      if (events === undefined) return [];
      var evlistener = events[type];
      if (evlistener === undefined) return [];
      if (typeof evlistener === 'function') return unwrap ? [evlistener.listener || evlistener] : [evlistener];
      return unwrap ? unwrapListeners(evlistener) : arrayClone(evlistener, evlistener.length);
    }
    EventEmitter.prototype.listeners = function listeners(type) {
      return _listeners(this, type, true);
    };
    EventEmitter.prototype.rawListeners = function rawListeners(type) {
      return _listeners(this, type, false);
    };
    EventEmitter.listenerCount = function (emitter, type) {
      if (typeof emitter.listenerCount === 'function') {
        return emitter.listenerCount(type);
      } else {
        return listenerCount.call(emitter, type);
      }
    };
    EventEmitter.prototype.listenerCount = listenerCount;
    function listenerCount(type) {
      var events = this._events;
      if (events !== undefined) {
        var evlistener = events[type];
        if (typeof evlistener === 'function') {
          return 1;
        } else if (evlistener !== undefined) {
          return evlistener.length;
        }
      }
      return 0;
    }
    EventEmitter.prototype.eventNames = function eventNames() {
      return this._eventsCount > 0 ? ReflectOwnKeys(this._events) : [];
    };
    function arrayClone(arr, n) {
      var copy = new Array(n);
      for (var i = 0; i < n; ++i) copy[i] = arr[i];
      return copy;
    }
    function spliceOne(list, index) {
      for (; index + 1 < list.length; index++) list[index] = list[index + 1];
      list.pop();
    }
    function unwrapListeners(arr) {
      var ret = new Array(arr.length);
      for (var i = 0; i < ret.length; ++i) {
        ret[i] = arr[i].listener || arr[i];
      }
      return ret;
    }
    function once(emitter, name) {
      return new Promise(function (resolve, reject) {
        function errorListener(err) {
          emitter.removeListener(name, resolver);
          reject(err);
        }
        function resolver() {
          if (typeof emitter.removeListener === 'function') {
            emitter.removeListener('error', errorListener);
          }
          resolve([].slice.call(arguments));
        }
        eventTargetAgnosticAddListener(emitter, name, resolver, {
          once: true
        });
        if (name !== 'error') {
          addErrorHandlerIfEventEmitter(emitter, errorListener, {
            once: true
          });
        }
      });
    }
    function addErrorHandlerIfEventEmitter(emitter, handler, flags) {
      if (typeof emitter.on === 'function') {
        eventTargetAgnosticAddListener(emitter, 'error', handler, flags);
      }
    }
    function eventTargetAgnosticAddListener(emitter, name, listener, flags) {
      if (typeof emitter.on === 'function') {
        if (flags.once) {
          emitter.once(name, listener);
        } else {
          emitter.on(name, listener);
        }
      } else if (typeof emitter.addEventListener === 'function') {
        // EventTarget does not have `error` event semantics like Node
        // EventEmitters, we do not listen for `error` events here.
        emitter.addEventListener(name, function wrapListener(arg) {
          // IE does not have builtin `{ once: true }` support so we
          // have to do it manually.
          if (flags.once) {
            emitter.removeEventListener(name, wrapListener);
          }
          listener(arg);
        });
      } else {
        throw new TypeError('The "emitter" argument must be of type EventEmitter. Received type ' + typeof emitter);
      }
    }

    /**
     * @file 常量配置
     * @author caigang@baidu.com
     */
    // 图片宽高尺寸阈值
    var IMG_WIDTH_HEIGHT_THRESHOLD = 1500;

    // 画布模式
    var ICanvasMode;
    (function (ICanvasMode) {
        // 移动模式
        ICanvasMode["MOVE"] = "MOVE";
        // 涂抹模式
        ICanvasMode["BRUSH"] = "BRUSH";
    })(ICanvasMode || (ICanvasMode = {}));
    var EventList;
    (function (EventList) {
        // 画布缩放倍数
        EventList["SCALECHANGED"] = "scaleChanged";
        // 是否开始涂抹
        EventList["HASTOUCH"] = "hasTouch";
        // 是否涂抹结束
        EventList["BRUSHEND"] = "brushEnd";
        // 缩放是否结束
        EventList["MOVEEND"] = "moveEnd";
        // 重绘画布
        // 撤销回退时候 需要编辑器需要更新绘制状态
        EventList["REDRAW"] = "redraw";
        // 笔迹相关信息
        EventList["STROKEDATA"] = "strokeData";
    })(EventList || (EventList = {}));
    var PLATFORM;
    (function (PLATFORM) {
        PLATFORM["WISE"] = "wise";
        PLATFORM["PC"] = "pc";
    })(PLATFORM || (PLATFORM = {}));

    /**
     * 撤销和重做
     */
    var revoke = /** @class */ (function (_super) {
        __extends(revoke, _super);
        function revoke(mainCanvasCtx, originWidth, originHeight) {
            var _this = _super.call(this) || this;
            _this.mainCanvasCtx = mainCanvasCtx;
            _this.originHeight = originHeight;
            _this.originWidth = originWidth;
            _this.strokeHistory = [];
            _this.strokeHistoryIndex = -1;
            return _this;
        }
        revoke.prototype.updateStrokeData = function () {
            return {
                strokeHistoryIndex: this.strokeHistoryIndex,
                strokeHistory: this.strokeHistory
            };
        };
        revoke.prototype.updateOrigin = function (width, height) {
            this.originWidth = width;
            this.originHeight = height;
        };
        revoke.prototype.saveStroke = function () {
            if (this.strokeHistoryIndex + 1 !== this.strokeHistory.length) {
                this.strokeHistory.splice(this.strokeHistoryIndex + 1, this.strokeHistory.length - this.strokeHistoryIndex - 1);
            }
            this.strokeHistory.push((this.mainCanvasCtx.getImageData(0, 0, this.originWidth, this.originHeight)));
            this.strokeHistoryIndex++;
            this.updateStrokeData();
        };
        revoke.prototype.updateStrokeHistory = function (params) {
            // 创建新的引用 为了和外部的引用分离
            this.strokeHistory = __spreadArray([], params.strokeHistory, true);
            this.strokeHistoryIndex = params.strokeHistoryIndex;
            this.updateStrokeData();
        };
        revoke.prototype.redrawCanvas = function (params) {
            var strokeImageData = params.strokeImageData;
            if (!strokeImageData) {
                this.mainCanvasCtx.clearRect(0, 0, this.originWidth, this.originHeight);
                return;
            }
            this.mainCanvasCtx.putImageData(strokeImageData, 0, 0);
            this.emit(EventList.REDRAW);
        };
        revoke.prototype.handleUndoClick = function () {
            this.strokeHistoryIndex--;
            this.redrawCanvas({
                strokeImageData: this.strokeHistoryIndex >= 0 ? this.strokeHistory[this.strokeHistoryIndex] : null
            });
            this.updateStrokeData();
        };
        revoke.prototype.handleRedoClick = function () {
            this.strokeHistoryIndex++;
            this.redrawCanvas({
                strokeImageData: this.strokeHistory[this.strokeHistoryIndex],
            });
            this.updateStrokeData();
        };
        return revoke;
    }(eventsExports));

    function setStyle(obj, sty) {
        for (var prop in sty) {
            if (Object.prototype.hasOwnProperty.call(sty, prop)) {
                // @ts-ignore
                obj.style[prop] = sty[prop];
            }
        }
    }

    var ImageEdit = /** @class */ (function (_super) {
        __extends(ImageEdit, _super);
        function ImageEdit(root, options) {
            var _this_1 = _super.call(this) || this;
            _this_1.platform = '';
            _this_1.$root = root;
            _this_1.brushWidth = options.brushWidth || 50;
            _this_1.brushColor = options.brushColor || 'rgb(235, 51, 51)';
            _this_1.drawPenStyle = options.drawPenStyle || {};
            _this_1.imageSrc = options.imageSrc;
            _this_1.imageWidth = options.imageWidth;
            _this_1.imageHeight = options.imageHeight;
            _this_1.minZoom = options.minZoom || 0.25;
            _this_1.maxZoom = options.maxZoom || 2;
            _this_1.canvasMode = null;
            _this_1.canBrushFlag = false;
            _this_1.canMoveFlag = true;
            _this_1.isPaint = false;
            var rootRect = _this_1.$root.getBoundingClientRect();
            // 容器尺寸
            _this_1.innerWidth = rootRect.width;
            _this_1.innerHeight = rootRect.height;
            // 画布放大倍数
            _this_1.canvasScale = 1;
            // 画布偏移量
            _this_1.canvasWrapLeft = 0;
            _this_1.canvasWrapTop = 0;
            // 画布初始化展示的宽高，且用来初始化canvas的width、height，后续用来计算画布放大和缩小
            _this_1.originWidth = 0;
            _this_1.originHeight = 0;
            _this_1.renderEditDom();
            _this_1.initRevoke();
            return _this_1;
        }
        ImageEdit.prototype.initRevoke = function () {
            var _this = this;
            this.revokeInstance = new revoke(this.mainCanvasCtx, this.originWidth, this.originHeight);
            this.revokeInstance.on(EventList.REDRAW, function () {
                _this.isPaint = true;
            });
        };
        /**
         * 获取画布布局信息
         *
         * @returns {{ width: number, height: number, top: number, left: number }} 包含画布布局信息的对象
         */
        ImageEdit.prototype.getCanvasLayoutInfo = function () {
            if (!this.imageHeight || !this.innerHeight) {
                return {};
            }
            var imgRatio = this.imageWidth / this.imageHeight;
            var ratio = this.innerWidth / this.innerHeight;
            var width = 0;
            var height = 0;
            if (ratio > imgRatio) {
                width = this.innerHeight * imgRatio;
                height = this.innerHeight;
            }
            else {
                height = this.innerWidth / imgRatio;
                width = this.innerWidth;
            }
            this.originWidth = width;
            this.originHeight = height;
            this.revokeInstance && this.revokeInstance.updateOrigin(width, height);
            var curWidth = width * this.canvasScale;
            var curHeight = height * this.canvasScale;
            this.canvasWrapTop = (this.innerHeight - curHeight) / 2;
            this.canvasWrapLeft = (this.innerWidth - curWidth) / 2;
            return {
                width: curWidth,
                height: curHeight,
                top: this.canvasWrapTop,
                left: this.canvasWrapLeft
            };
        };
        /**
         * 设置画笔宽度
         *
         * @param width 画笔宽度
         */
        ImageEdit.prototype.setBrushWidth = function (width) {
            if (!width || !this.mainCanvasCtx) {
                return;
            }
            this.mainCanvasCtx.lineWidth = width / this.canvasScale;
            this.brushWidth = width;
        };
        /**
         * 初始化画布上下文
         */
        ImageEdit.prototype.initCanvasCtx = function () {
            if (!this.$mainCanvas) {
                return;
            }
            this.mainCanvasCtx = this.mainCanvasCtx || this.$mainCanvas.getContext('2d');
            this.$mainCanvas.width = this.originWidth;
            this.$mainCanvas.height = this.originHeight;
            if (this.mainCanvasCtx) {
                this.mainCanvasCtx.clearRect(0, 0, this.originWidth, this.originHeight);
                this.mainCanvasCtx.lineCap = 'round';
                this.mainCanvasCtx.fillStyle = this.brushColor;
                this.mainCanvasCtx.strokeStyle = this.brushColor;
                if (this.drawPenStyle) {
                    setStyle(this.$drawPen, this.drawPenStyle);
                }
            }
            this.setBrushWidth(this.brushWidth);
        };
        /**
         * 渲染编辑DOM
         */
        ImageEdit.prototype.renderEditDom = function () {
            var layout = this.getCanvasLayoutInfo();
            var template = "\n            <div class=\"editor-container\" style=\"position: relative; width: 100%; height: 100%;overflow: hidden;\">\n                <div class=\"edit-canvas-wrap\"\n                    style=\"overflow: hidden;\n                        width: ".concat(layout.width, "px;\n                        height: ").concat(layout.height, "px;\n                        position: absolute;\n                        top: ").concat(layout.top, "px;\n                        left: ").concat(layout.left, "px;\n                        background-image: url(").concat(this.imageSrc, ");\n                        background-repeat: no-repeat;\n                        background-size: 100% 100%;\"\n                    >\n                        <canvas\n                            id=\"mainCanvas\"\n                            style=\"opacity: 0.45; width: 100%; height: 100%;\"\n                            width=\"").concat(layout.width, "\"\n                            height=\"").concat(layout.height, "\"\n                        >\n                        </canvas>\n\n                        <div\n                            class=\"edit-draw-pen\"\n                            style=\"\n                                position: absolute;\n                                display: none;\n                                transform: translate(-50%, -50%);\n                                border: 1px solid #DBDCE0;\n                                pointer-events: none;\n                                border-radius: 50%;\n                                background-color: rgba(255,255,255,.3);\n                            \">\n                        </div>\n                <div>\n            </div>");
            // bca-disable-line
            this.$root.innerHTML = template;
            this.$mainCanvas = this.$root.querySelector('#mainCanvas');
            this.$canvasWrap = this.$root.querySelector('.edit-canvas-wrap');
            this.$drawPen = this.$root.querySelector('.edit-draw-pen');
            this.initCanvasCtx();
        };
        /**
         * 画布缩放
         * @param scale 缩放倍数
         * @param center 缩放中心点
         */
        ImageEdit.prototype.zoom = function (scale, center) {
            if (typeof scale !== 'number' || scale === this.canvasScale) {
                return;
            }
            var canvasWrapEle = this.$canvasWrap;
            var rect = canvasWrapEle.getBoundingClientRect();
            var left = rect.left, top = rect.top, curWidth = rect.width, curHeight = rect.height;
            var scaleWidth = this.originWidth * scale;
            var scaleHeight = this.originHeight * scale;
            // 手动缩放时，设置缩放中心点为元素的中心点；鼠标滚轮缩放时，缩放中心点为鼠标当前坐标
            center = center || {
                clientX: left + curWidth / 2,
                clientY: top + curHeight / 2
            };
            // 计算缩放后的偏移量
            var deltaX = (center.clientX - left) * (Math.round(scaleWidth) - curWidth) / curWidth;
            var deltaY = (center.clientY - top) * (Math.round(scaleHeight) - curHeight) / curHeight;
            // 更新 canvasWrap 的位置和尺寸
            this.canvasWrapLeft -= deltaX;
            this.canvasWrapTop -= deltaY;
            setStyle(this.$canvasWrap, {
                width: "".concat(scaleWidth, "px"),
                height: "".concat(scaleHeight, "px"),
                left: "".concat(this.canvasWrapLeft, "px"),
                top: "".concat(this.canvasWrapTop, "px")
            });
            this.canvasScale = scale;
            this.emit(EventList.SCALECHANGED, {
                scale: Math.round(this.canvasScale * 1000) / 1000
            });
            // 更新画笔宽度
            if (this.mainCanvasCtx) {
                this.mainCanvasCtx.lineWidth = this.brushWidth / this.canvasScale;
            }
        };
        /**
         * 设置画布为移动模式
         */
        ImageEdit.prototype.move = function (flag) {
            this.canvasMode = flag ? ICanvasMode.MOVE : null;
            setStyle(this.$drawPen, {
                display: 'none'
            });
        };
        /**
         * 设置画布为笔刷模式
         */
        ImageEdit.prototype.brush = function (flag) {
            this.canvasMode = flag ? ICanvasMode.BRUSH : null;
        };
        /**
         * 设置画布是否可涂抹
         */
        ImageEdit.prototype.canBrush = function (flag) {
            this.canBrushFlag = flag;
        };
        /**
         * 设置画布是否可移动
         * @param flag true 移动，false 不移动
         */
        ImageEdit.prototype.canMove = function (flag) {
            this.canMoveFlag = flag;
        };
        /**
         * 处理绘制操作
         *
         * @param startPos 起始点坐标，包含起始X和起始Y两个属性
         * @param endPos 终止点坐标，包含终止X和终止Y两个属性
         */
        ImageEdit.prototype.handlePaint = function (startPos, endPos) {
            this.isPaint = true;
            var ctx = this.mainCanvasCtx;
            if (!ctx) {
                return;
            }
            var dpr = 1 / this.canvasScale;
            ctx.beginPath();
            ctx.moveTo(startPos.startX * dpr, startPos.startY * dpr);
            ctx.lineTo(endPos.endX * dpr, endPos.endY * dpr);
            ctx.stroke();
        };
        /**
         * 绘制圆点
         *
         * @param centerX 圆心x坐标
         * @param centerY 圆心y坐标
         */
        ImageEdit.prototype.handlePaintCircle = function (centerX, centerY) {
            this.isPaint = true;
            var ctx = this.mainCanvasCtx;
            if (!ctx) {
                return;
            }
            var dpr = 1 / this.canvasScale;
            ctx.beginPath();
            ctx.arc(centerX * dpr, centerY * dpr, this.brushWidth / (this.canvasScale * 2), 0, 2 * Math.PI, false);
            ctx.fill();
            ctx.closePath();
        };
        /**
         * 清空画布
         */
        ImageEdit.prototype.clearCanvas = function () {
            if (!this.mainCanvasCtx) {
                return;
            }
            this.isPaint = false;
            setStyle(this.$drawPen, {
                display: 'none'
            });
            this.mainCanvasCtx.clearRect(0, 0, this.originWidth, this.originHeight);
            this._updateStrokeData();
        };
        /**
         * 重置画图, 清空画布并重置画布上下文
         */
        ImageEdit.prototype.reset = function () {
            this.canvasMode = null;
            this.canvasScale = 1;
            this.resize();
            this.clearCanvas();
            this.initCanvasCtx();
            this.emit(EventList.SCALECHANGED, {
                scale: 1
            });
            setStyle(this.$drawPen, {
                display: 'none'
            });
        };
        /**
         * 重置画布大小
         */
        ImageEdit.prototype.resize = function () {
            var rootRect = this.$root.getBoundingClientRect();
            // 容器尺寸
            this.innerWidth = rootRect.width;
            this.innerHeight = rootRect.height;
            var oldWidth = this.originWidth;
            var layout = this.getCanvasLayoutInfo();
            setStyle(this.$canvasWrap, {
                width: "".concat(layout.width, "px"),
                height: "".concat(layout.height, "px"),
                left: "".concat(layout.left, "px"),
                top: "".concat(layout.top, "px")
            });
            if (this.mainCanvasCtx) {
                this.mainCanvasCtx.scale(oldWidth / this.originWidth, oldWidth / this.originWidth);
            }
        };
        /**
         * 更新图片
         */
        ImageEdit.prototype.updateImage = function (params) {
            if (!params.src || !params.width || !params.height) {
                return;
            }
            this.imageSrc = params.src;
            this.imageWidth = params.width;
            this.imageHeight = params.height;
            this.canvasMode = null;
            this.canvasScale = 1;
            var layout = this.getCanvasLayoutInfo();
            setStyle(this.$canvasWrap, {
                width: "".concat(layout.width, "px"),
                height: "".concat(layout.height, "px"),
                left: "".concat(layout.left, "px"),
                top: "".concat(layout.top, "px"),
                backgroundImage: "url(".concat(this.imageSrc, ")")
            });
            setStyle(this.$drawPen, {
                display: 'none'
            });
            this.clearCanvas();
            this.initCanvasCtx();
            this.emit(EventList.SCALECHANGED, {
                scale: this.canvasScale
            });
        };
        ImageEdit.prototype.resizeDimensions = function (width, height, maxWidth, maxHeight) {
            // PC 端不做处理
            if (this.platform === PLATFORM.PC) {
                return { width: width, height: height };
            }
            // 定义最大宽度和高度
            var maxDim = Math.max(maxWidth, maxHeight);
            // 检查是否需要缩放
            if (width > maxDim || height > maxDim) {
                // 计算缩放比例
                var ratio = Math.min(maxDim / width, maxDim / height);
                // 应用缩放比例
                width = Math.round(width * ratio);
                height = Math.round(height * ratio);
            }
            // 返回新的尺寸
            return { width: width, height: height };
        };
        /**
         * 获取涂抹图片的位置
         * @returns base64 || ''
         */
        ImageEdit.prototype.getCanvasDataURL = function () {
            var _a;
            if (!this.isPaint) {
                return '';
            }
            // 清理旧的 canvas 元素
            if (this.$paintCanvas) {
                document.body.removeChild(this.$paintCanvas);
            }
            (_a = this.$paintCanvasCtx) === null || _a === void 0 ? void 0 : _a.clearRect(0, 0, this.imageWidth, this.imageHeight);
            var resultCanvas = document.createElement('canvas');
            // 使 resultCanvas 在页面中不可见
            setStyle(resultCanvas, {
                position: 'fixed',
                left: '-9999999px',
                top: '9999999px'
            });
            document.body.appendChild(resultCanvas);
            var resultCtx = resultCanvas.getContext('2d');
            // @caigang 生成的 base64 图片限制在宽高 1500px 以内，否则 iOS 会生成失败
            // 只要保证尺寸一致，策略可以保证生图效果
            var _b = this.resizeDimensions(this.imageWidth, this.imageHeight, IMG_WIDTH_HEIGHT_THRESHOLD, IMG_WIDTH_HEIGHT_THRESHOLD), imageWidth = _b.width, imageHeight = _b.height;
            resultCanvas.width = imageWidth;
            resultCanvas.height = imageHeight;
            resultCtx.fillStyle = '#000';
            resultCtx.fillRect(0, 0, imageWidth, imageHeight);
            // 将 main 作为 image 的 mask
            if (this.$mainCanvas) {
                resultCtx.drawImage(this.$mainCanvas, 0, 0, imageWidth, imageHeight);
            }
            var maskedData = resultCtx.getImageData(0, 0, imageWidth, imageHeight);
            var maskedPixels = maskedData.data;
            for (var i = 0; i < maskedPixels.length; i += 4) {
                if (maskedPixels[i] > 0) {
                    // 如果 main 的红色通道有值，说明是绘图区域， 将mask转为涂抹区为白色，背景为黑色的图
                    maskedPixels[i] = 255;
                    maskedPixels[i + 1] = 255;
                    maskedPixels[i + 2] = 255;
                    maskedPixels[i + 3] = 255;
                }
            }
            resultCtx.putImageData(maskedData, 0, 0);
            this.$paintCanvas = resultCanvas;
            this.$paintCanvasCtx = resultCtx;
            return resultCanvas.toDataURL('image/jpeg', 1);
        };
        /**
         * 将图片转为base64格式
         *
         * @param src 图片链接地址
         * @param w 图片宽度
         * @param h 图片高度
         * @param options 图片处理参数，可选参数：type(输出图片格式，默认为jpeg)，quality(输出图片质量，默认为1)
         * @returns Promise对象，返回base64格式的图片地址
         */
        ImageEdit.prototype.getBase64Image = function (src, w, h, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(this, void 0, void 0, function () {
                var resultCanvas, resultCtx, image, loadImage;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            options = __assign({ type: 'jpeg', quality: 1 }, options);
                            if (src.indexOf('data:image') >= 0) {
                                return [2 /*return*/, src];
                            }
                            resultCanvas = document.createElement('canvas');
                            resultCtx = resultCanvas.getContext('2d');
                            resultCanvas.width = w;
                            resultCanvas.height = h;
                            image = new Image();
                            image.crossOrigin = 'anonymous';
                            loadImage = function (url) {
                                return new Promise(function (resolve) {
                                    image.onload = function () {
                                        resultCtx.drawImage(image, 0, 0, w, h);
                                        resolve();
                                    };
                                    image.onerror = function () {
                                        resolve();
                                    };
                                    image.src = url;
                                });
                            };
                            return [4 /*yield*/, loadImage(src)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, resultCanvas.toDataURL("image/".concat(options.type), options.quality)];
                    }
                });
            });
        };
        /**
         * 销毁实例对象，释放资源
         */
        ImageEdit.prototype.destroy = function () {
            var _a;
            this.$mainCanvas = null;
            this.mainCanvasCtx.clearRect(0, 0, this.originWidth, this.originHeight);
            if (this.$paintCanvas) {
                document.body.removeChild(this.$paintCanvas);
            }
            (_a = this.$paintCanvasCtx) === null || _a === void 0 ? void 0 : _a.clearRect(0, 0, this.imageWidth, this.imageHeight);
        };
        /**
         * 更新当前笔迹信息
         */
        ImageEdit.prototype._updateStrokeData = function () {
            this.emit(EventList.STROKEDATA, this.revokeInstance.updateStrokeData());
        };
        ImageEdit.prototype.saveStroke = function () {
            this.revokeInstance.saveStroke();
            this._updateStrokeData();
        };
        /**
         * 重新绘制笔迹
         * @param params.strokeImageData 笔迹数据
         */
        ImageEdit.prototype.redrawCanvas = function (params) {
            this.revokeInstance.redrawCanvas(params);
            this.isPaint = true;
        };
        /**
         * 更新当前图片对应的笔迹数据
         * @param params.strokeHistory 笔迹历史
         * @param params.strokeHistoryIndex 笔迹索引
         */
        ImageEdit.prototype.updateStrokeHistory = function (params) {
            this.revokeInstance.updateStrokeHistory(params);
            this._updateStrokeData();
        };
        /**
         * 笔迹撤销
         */
        ImageEdit.prototype.handleUndoClick = function () {
            this.revokeInstance.handleUndoClick();
            this._updateStrokeData();
        };
        /**
         * 笔迹回退
         */
        ImageEdit.prototype.handleRedoClick = function () {
            this.revokeInstance.handleRedoClick();
            this._updateStrokeData();
        };
        return ImageEdit;
    }(eventsExports));

    var PCImageEdit = /** @class */ (function (_super) {
        __extends(PCImageEdit, _super);
        /**
         * 构造函数，初始化对象
         *
         * @param root - 根元素
         * @param options - 配置选项
         */
        function PCImageEdit(root, options) {
            var _this = _super.call(this, root, options) || this;
            _this.handleOnwheel = function (event) {
                if (!_this.isWheelZoom) {
                    return;
                }
                event.stopPropagation();
                event.preventDefault();
                // @ts-ignore
                var wheelDelta = event.wheelDelta || event.deltaY * -1;
                var newScale = _this.canvasScale + 0.1 * (wheelDelta > 0 ? 1 : -1);
                var scale = Math.max(_this.minZoom, Math.min(_this.maxZoom, newScale));
                _this.zoom(scale, {
                    clientX: event.clientX,
                    clientY: event.clientY
                });
            };
            _this.handleMouseMove = function (event) {
                if (_this.canvasMode !== 'BRUSH') {
                    return;
                }
                var layout = _this.$canvasWrap.getBoundingClientRect();
                var newX = event.clientX - layout.left;
                var newY = event.clientY - layout.top;
                // 画笔移动
                setStyle(_this.$drawPen, {
                    left: newX + 'px',
                    top: newY + 'px'
                });
                if (_this.isMouseDown) {
                    _this.isPaint = true;
                    _this.handlePaint({
                        startX: _this.lastMouseX,
                        startY: _this.lastMouseY
                    }, {
                        endX: newX,
                        endY: newY
                    });
                    _this.lastMouseX = newX;
                    _this.lastMouseY = newY;
                }
            };
            _this.handleMouseUp = function (event) {
                var target = event.target;
                if (_this.canvasMode === 'BRUSH' && _this.isMouseDown) {
                    _this.emit(EventList.BRUSHEND);
                    _this.saveStroke();
                    if (target && target.id !== 'mainCanvas' && target.tagName !== 'CANVAS') {
                        setStyle(_this.$drawPen, {
                            display: 'none',
                        });
                    }
                }
                _this.isMouseDown = false;
            };
            // 控住画布拖拽
            _this.handleMoveMode = function (downX, downY) {
                // 获取上次移动完成的偏移量
                var container = _this.$root;
                var top = _this.canvasWrapTop;
                var left = _this.canvasWrapLeft;
                document.onmousemove = function (event) {
                    event.stopPropagation();
                    event.preventDefault();
                    var moveX = event.clientX;
                    var moveY = event.clientY;
                    _this.canvasWrapLeft = left + (moveX - downX);
                    _this.canvasWrapTop = top + (moveY - downY);
                    setStyle(_this.$canvasWrap, {
                        left: _this.canvasWrapLeft + 'px',
                        top: _this.canvasWrapTop + 'px'
                    });
                };
                container.onmouseout = document.onmouseup = function (event) {
                    event.stopPropagation();
                    event.preventDefault();
                    document.onmousemove = null;
                    container.onmouseout = document.onmouseup = null;
                };
            };
            _this.handleMouseDown = function (event) {
                event.stopPropagation();
                event.preventDefault();
                // 获取当前鼠标坐标
                var downX = event.clientX;
                var downY = event.clientY;
                var layout = _this.$canvasWrap.getBoundingClientRect();
                // 根据鼠标状态判断执行什么方法
                switch (_this.canvasMode) {
                    case 'MOVE':
                        _this.handleMoveMode(downX, downY);
                        break;
                    case 'BRUSH':
                        _this.isMouseDown = true;
                        _this.lastMouseX = event.clientX - layout.left;
                        _this.lastMouseY = event.clientY - layout.top;
                        _this.handlePaint({
                            startX: _this.lastMouseX,
                            startY: _this.lastMouseY
                        }, {
                            endX: _this.lastMouseX + 0.1,
                            endY: _this.lastMouseY + 0.1
                        });
                        break;
                }
            };
            _this.handleMouseEnter = function (event) {
                _this.emit(EventList.HASTOUCH, {
                    canBrush: _this.canBrushFlag
                });
                switch (_this.canvasMode) {
                    case 'MOVE':
                        if (_this.$mainCanvas) {
                            setStyle(_this.$mainCanvas, {
                                cursor: 'grab'
                            });
                        }
                        setStyle(_this.$drawPen, {
                            display: 'none',
                        });
                        break;
                    case 'BRUSH':
                        if (_this.$mainCanvas) {
                            setStyle(_this.$mainCanvas, {
                                cursor: 'none'
                            });
                        }
                        setStyle(_this.$drawPen, {
                            display: 'block',
                            width: _this.brushWidth + 'px',
                            height: _this.brushWidth + 'px',
                            left: event.offsetX + 'px',
                            top: event.offsetY + 'px'
                        });
                        break;
                    default:
                        if (_this.$mainCanvas) {
                            setStyle(_this.$mainCanvas, {
                                cursor: 'auto'
                            });
                            setStyle(_this.$drawPen, {
                                display: 'none'
                            });
                        }
                        break;
                }
            };
            _this.handleMouseOut = function () {
                if (_this.isMouseDown) {
                    return;
                }
                setStyle(_this.$drawPen, {
                    display: 'none'
                });
            };
            _this.handleContextmenu = function (event) {
                // 图片区域禁用鼠标右键，防止未登录保存
                event.preventDefault();
                event.stopPropagation();
            };
            _this.platform = PLATFORM.PC;
            _this.isWheelZoom = true;
            _this.isMouseDown = false;
            _this.lastMouseX = 0;
            _this.lastMouseY = 0;
            _this.bindEvents();
            return _this;
        }
        /**
         * 绑定事件
         */
        PCImageEdit.prototype.bindEvents = function () {
            this.$canvasWrap.addEventListener('wheel', this.handleOnwheel);
            this.$canvasWrap.addEventListener('mousedown', this.handleMouseDown);
            this.$canvasWrap.addEventListener('mouseenter', this.handleMouseEnter);
            this.$canvasWrap.addEventListener('mouseout', this.handleMouseOut);
            this.$canvasWrap.addEventListener('contextmenu', this.handleContextmenu);
            document.addEventListener('mousemove', this.handleMouseMove);
            document.addEventListener('mouseup', this.handleMouseUp);
        };
        /**
         * 解绑事件
         */
        PCImageEdit.prototype.unbindEvents = function () {
            this.$canvasWrap.removeEventListener('wheel', this.handleOnwheel);
            this.$canvasWrap.removeEventListener('mousedown', this.handleMouseDown);
            this.$canvasWrap.removeEventListener('mouseenter', this.handleMouseEnter);
            this.$canvasWrap.removeEventListener('mouseout', this.handleMouseOut);
            this.$canvasWrap.removeEventListener('contextmenu', this.handleContextmenu);
            document.removeEventListener('mousemove', this.handleMouseMove);
            document.removeEventListener('mouseup', this.handleMouseUp);
        };
        /**
         * 是否允许滚轴缩放
         * @param flag boolean
         */
        PCImageEdit.prototype.allowWhellZoom = function (flag) {
            this.isWheelZoom = flag;
        };
        PCImageEdit.prototype.reset = function () {
            _super.prototype.reset.call(this);
            this.isWheelZoom = true;
        };
        /**
         * 销毁
         */
        PCImageEdit.prototype.destroy = function () {
            _super.prototype.destroy.call(this);
            this.unbindEvents();
        };
        return PCImageEdit;
    }(ImageEdit));

    exports.PCImageEdit = PCImageEdit;

}));
